//*********************************************************************************************************************
//	Warning, this is another MonsterHunt version containing some fixations and improvements
//	As an attached version, won't be good to be used in maps designed in purpose only for MonsterHunt.MonsterHunt
//	as game-type. If you think this is a problem, go ahead and mess with default version 5.03 or worse.
//	I added a credits menu to show the origins of more codes added in this version (visible as player with
//	this mod placed inside UT99 game), of course I'm not so smart to do alone all these, te, he... but I fixed what I needed.
//	I wasn't so glad for this work because was not so easy, and still can be something "invisible" in controller
//	creating bugs, hard to be noticed or at least for me this is what I could do after some versions released.
//	This version can be as a good-to-see one. If you don't like how is done, use other MH, or fix it as you wish...
//	Following lines are the Main Game Controller containing also descriptions (bad or good take them as you want
//	as a joke or serious depends on what you want to do), are just my opinions, you can add your own or remove them
//**********************************************************************************************************************
class MonsterHunt2 expands Domination 	//We start as a subclass of a .... TeamGamePlus which belongs to DeadMatchPlus...
	config(MH2_NS_V2);			//some values are just called coming from deep root (GameInfo) to Tournament form.

var config bool bUseTeamSkin, bNoGreen, bDoSpawnSpamFix, bFixCounters;	//New values used for controller are declared for this game-type
var config string StartUpMessage, StartUpTeamMessage;	//Config means configurable in file declared in parenthesis
var (AI) config name TT;
//Actually I don't want to hear about old names for values, I don't want any null call...
//Don't be panicated, MonsterHunt is in this package subclassing this new one to avoid
//old stupid calls creating accesed nones...
var config int Live, SkillMonster, Ncheck;
var int TN, LastPt, NumPts;
var config float Pen;
var bool bUseLive, bStupidMap, bGarbRemoved, bStartedHunt, fakeorder, bHaveTeleports, bHaveASpawn, bSpeedRefresh;
var string TimeOutMessage;
var int LivePpl, PlainPpl, TotalMonsters, TotalHunters;
var Actor MHTarget;
var NavigationPoint PointToTarget;


event PreBeginPlay() //Don't call me too much - Screwed
{
	StartTime = 0;
//	SetGameSpeed(GameSpeed); //Not in here
	Level.bNoCheating = bNoCheating;
	Level.bAllowFOV = bAllowFOV;
	if (GameReplicationInfoClass != None)
		GameReplicationInfo = Spawn(GameReplicationInfoClass);
	else
		GameReplicationInfo = Spawn(class'GameReplicationInfo');
	InitGameReplicationInfo();
}


function PostBeginPlay()	//Looking at logs will see this controller initialized AFTER BaseMutator called
{							//And NOT Before (Game Rules not my rules)
	local int i;
	local PathNode PN;
	local NavigationPoint Np;
	local Pawn P;
	local ScriptedPawn S;
	local pawn pawnlink;
	local MonsterWaypoint WP;	//Solved ? Yup, Somehow :D
	local NsWayPoint Nwe;		//New Technology ? - Call this A.I. level 2 in MH.
//	local MonsterEnd ME;
//	local MonsterEnd2 ex;
	local Trigger Tr, Trp;

	log ("MH2_NS_V2.MonsterHunt game-mod started root initialization procedures...");
	bGarbRemoved = False;
	bHaveTeleports = False;
//	DoSpawnFix();
	foreach AllActors(class'ScriptedPawn', S)	//Actually this is a kind of hack to make monsters relaxed before starting game
	{						//before starting game, can be 500, more or less,
		if (S != None )		//won't spent too much time for this, game is still initializing and waiting will be called
		{
			if ( !S.IsA('Nali') && !S.IsA('Cow') )
			{
				S.AttitudeToPlayer = ATTITUDE_Ignore;
			}
		}
	}
	//Check anti-bullshit
	if (Ncheck < 20)
		Ncheck = 20;
	if (Ncheck > 150)
		Ncheck = 20;
	if (Pen < 0.5)
		Pen = 0.5;
	if (Pen > 0.98)
		Pen = 0.98;

	TN = 0;

	foreach AllActors (class 'NavigationPoint', Np)
	{
		if ( Np != none )
		{
			if ( Np.IsA('PathNode') )
				TN++;
			if ( Np.IsA ('Teleporter') && !bHaveTeleports )
				bHaveTeleports = True;
		}
	}

	if (TN < Ncheck)
		bStupidMap=True; //Often meet case :(
	else
		bStupidMap=False; //Better this case but isn't often

	if (bNoGreen)
		StopGreens();
	if (bFixCounters)
		FixCounters();
	SetMusics();
	foreach AllActors (class 'MonsterWaypoint', WP) //Time to blast some ass :D
	{
		if (WP != None)
		{
			Nwe=Spawn(class'NsWayPoint',WP,,WP.Location + vect(0,0,1));
			if ( Nwe != None )
				Nwe.OldPoint = WP;
//			Removed Processes as long as our WayPoint is handling job alone
//			Also it starts immediately and I don't risk to set null values
//			NsWayPoint will perform a scan and clone data from older thing
		}
	}
	NumPts = 0; //I need some safe,
	foreach AllActors(class'NsWayPoint', Nwe)
	{
		if (Nwe != None)
			NumPts ++;
	}
	CountMonsters();
	MonsterReplicationInfo2(GameReplicationInfo).Monster = TotalMonsters;
	MonsterReplicationInfo2(GameReplicationInfo).Live = Live;
	MonsterReplicationInfo2(GameReplicationInfo).bUseTeamSkin = bUseTeamSkin;
	if ( MonsterReplicationInfo2(GameReplicationInfo).Live <= 0 )
		MonsterReplicationInfo2(GameReplicationInfo).bUseLive = False; //Oh, oh, Shrimp, Shrimp what other dumb ideas you had ?
	else
		MonsterReplicationInfo2(GameReplicationInfo).bUseLive = True;
	Super(TeamGamePlus).PostBeginPlay();
	log ("MH2 Controller finished PostBeginPlay...");
}

function DoSpawnfix()
{
	local SpawnPoint So, Sn;
	local ThingFactory Tf;
	local int i;

	ForEach AllActors ( class 'UnrealShare.SpawnPoint', So )
	{
		if ( So != None && So.class == class 'UnrealShare.SpawnPoint' )
		{
			Sn = Spawn(class 'MH2_NS_V2.SpawnPoint',,,So.Location+vect(0,0,1),So.Rotation);
			if ( Sn != None )
			{
//				Log (Sn$" spawned for "$So);
				if (So.Tag != '') Sn.SetPropertyText("Tag",So.GetPropertyText("Tag"));
				if (So.Event != '') Sn.SetPropertyText("Event",So.GetPropertyText("Event"));
				Sn.SetPropertyText("factory",So.GetPropertyText("factory"));
				So.SetPropertyText("Tag",("None"));
//				log (Sn$" new tag is "$Sn.Tag);
//				log ( So.Tag$" is the Tag from "$So);
			}
		}
	}
	ConsoleCommand ("Set PlayerStart TeamNumber 0"); //Yeah
}

function DoTheDirt() //this is the mostly for personal fun
{					//next time when I'm pissed off I'll launch more manure
	local Actor A;
	local String CC;

	foreach AllActors (class 'Actor',A )
	{
		if ( Carcass(A) != None )
		{
			if ( ( Carcass(A).bStatic || Carcass(A).bNoDelete ) && Carcass(A).bCollideActors )
			{
				CC = Caps(Carcass(A).class);
				CC = "set"@CC@"bStatic 0";
	//			log ("Command is"@CC);
				ConsoleCommand(CC);
				CC="";
				CC = Caps(Carcass(A).class);
				CC = "set"@CC@"bNoDelete 0";
	//			log ("Command is"@CC);
				ConsoleCommand(CC);
	//			log ("Found "$Carcass(A)$" now with bStatic="$Carcass(A).bStatic);
	//			log ("Also "$Carcass(A)$" with bNoDelete="$Carcass(A).bNoDelete);
				CC="";
				Carcass(A).Destroy();
			}
		}
		if ( Inventory(A) != None )
		{
			if (Inventory(A).bStatic || Inventory(A).bNoDelete )
			{
				Inventory(A).bRotatingPickup=False;
			}
		}
	}
}

function SetMusics()
{
	local MusicEvent Me;
	local SongKeeper Sk;

	foreach AllActors (class 'MusicEvent', Me)
	{
		if ( Me != None && Me.class == class 'MusicEvent' )
		{
			Me.SetCollision(False,False,False);
			Sk = Spawn(Class'SongKeeper',,,Me.Location+vect(0,0,1));
			if ( Sk != None )
			{
				Sk.SetPropertyText("Event",Me.GetPropertyText("Event")); //ih, not sure if needs
				Sk.SetPropertyText("Tag",Me.GetPropertyText("Tag"));
				Sk.SetPropertyText("Song",Me.GetPropertyText("Song"));
				Sk.SetPropertyText("SongSection",Me.GetPropertyText("SongSection"));
				Sk.SetPropertyText("CdTrack",Me.GetPropertyText("CdTrack"));
				Sk.SetPropertyText("Transition",Me.GetPropertyText("Transition"));
				Sk.SetPropertyText("bSilence",Me.GetPropertyText("bSilence"));
				Sk.SetPropertyText("bOnceOnly",Me.GetPropertyText("bOnceOnly"));
				Sk.SetPropertyText("bAffectAllPlayers",Me.GetPropertyText("bAffectAllPlayers"));
				Sk.SetCollisionSize(Me.CollisionRadius,Me.CollisionHeight);
				if (!Me.bStatic && !Me.bNoDelete)
				{
					Me.Disable('Trigger');
					Me.Tag = '';
				}
				log (Sk$" spawned for "$Me$" having song "$Sk.Song$" and bAffectAllPlayers "$Sk.bAffectAllPlayers);
			}
			else log ("Cannot set music keeper for "$Me);
		}
	}
}

// I think this is what I needed in end
// Self note: things are worst than I could dream about
// LevelInfo placed in Level from client probably won't really follow server's suggestion,
// only for stupid values when cannot really deal well with his data messing up with
// gamespeed suggested by server. If game is Classic and a stupid level has 5.000000 at TimeDilation then...
// This game doesn't really include NetCodes in end - poor and wacky coded messing its own engine
// Technically it has only Virtual NetCodes. I saw games from 1995 having better NetCodes :(

function SetGameSpeed(Float T)
{
	local float InitialSpeed;

	GameSpeed=FMax(T,0.1); //Initial setup could be awesome but is not
	InitialSpeed=GameSpeed;
	Level.TimeDilation=GameSpeed+0.000001/* *0.999999 */;		// Even in default MH using Classic Core from menu
	SetTimer(Level.TimeDilation, True);
	GameSpeed=InitialSpeed;				// game did not run normally with TimeDilation > 1 - Example at value 5 was a total mess
//	SaveConfig();
	log (Self@"> reports GameSpeed value ="@GameSpeed);
}

// Also it was double initialized causing some deviations
// Now looks more accurate
// Timer from TimedBoy has now values matching much better the real time.

function float PlaySpawnEffect(inventory Inv)
{
	if (Level.NetMode != NM_DedicatedServer)
		Playsound(sound'RespawnSound');
	spawn( class 'ReSpawn',,,Inv.Location );
		return 0.3;
}

function PlayTeleportEffect( actor Incoming, bool bOut, bool bSound)
{
	local PawnTeleportEffect PTE;

	if ( bRequireReady && (Countdown > 0) )
		return;

	if ( Pawn(Incoming) != None && (Incoming.Mesh != None) )
	{
		if ( bSound )
		{
			PTE = Spawn(class'PawnTeleportEffect',,, Incoming.Location, Incoming.Rotation);
			PTE.Initialize(Pawn(Incoming), bOut);
/*			if ( Incoming.IsA('PlayerPawn') )
				PlayerPawn(Incoming).SetFOVAngle(170);
*/
			Incoming.PlaySound(sound'Teleport1',, 10.0);
		}
	}
}

function FixCounters()
{
	local Counter C;
	local ECounter Ec;
	local int NRep;

	foreach AllActors(class'Counter',C)
	{
		if (C != None && C.Tag != '' && !C.IsA('ECounter'))
		{
			C.SetCollision(False,False,False);
			C.SetCollisionSize(0,0);
			Ec = Spawn (class 'ECounter',,,C.Location+vect(0,0,1));
			if ( Ec != None )
			{
				log ("Proceed to tweak Counter"@C);
				Ec.NumToCount = Clamp(C.NumToCount,1,254);
				Ec.bShowMessage = True;
				Ec.CompleteMessage = C.CompleteMessage;
				Ec.CountMessage = C.CountMessage;
				Ec.Event = C.Event;
				Ec.Tag = C.Tag;
				C.Disable('Touch');
				C.Disable('Trigger');
				C.Tag = '';
				C.Event = '';
				NRep++;
			}
		}
	}
	if ( NRep > 1 )
		log ("In this Level were replaced"@NRep@"Counters.");
	else
		log ("Counter has been replaced.");
}

function StopGreens()
{
	local MonsterEvent Moe; // =))... Sorry, I can't stop laughing...
	local ExSpecialEvent Ee;
	local string st;

	log ("Detected request for switching to Blue Messages.");
	ConsoleCommand("Set MonsterHunt.MonsterEvent bGameRelevent 0");
	ConsoleCommand("Set MonsterHunt.MonsterEvent bStatic 0");
	ConsoleCommand("Set MonsterHunt.MonsterEvent bNoDelete 0");
	ForEach AllActors(class 'MonsterEvent', Moe)
	{
		if (Moe != None)
		{
			Moe.SetCollision(false,false,false);
			Ee = Spawn(class 'MH2_NS_V2.ExSpecialEvent',,,Moe.location + vect(0, 0, 1)); //A bit higher, pls...
			if ( Ee != None )
			{
				if (Moe.Tag != '')
				{
					Ee.Tag = Moe.Tag;
					Moe.Tag = '';
				}
				if (Moe.Event != '')
				{
					Ee.event = Moe.Event;
					Moe.Event = '';
				}
				st = Moe.Message;
				Ee.Message = st;
				if (Moe.AttachTag != '') Ee.AttachTag = Moe.AttachTag;
				Ee.SetCollisionSize(Moe.CollisionRadius, Moe.CollisionHeight); //Zzzz
				if (Moe.bMovable) Ee.bMovable = True;
				else Ee.bMovable = False;
				if (!Moe.bStatic && !Moe.bNoDelete)
				{
					Moe.Disable('Trigger');
					Moe.Destroy();
				}
				log (Ee$" - new Message Trigger was succesfully added.");	//This line is for spy replacement
			}
		}
	}
	log ("Switching to Blue Messages has been ended."); //Meoow !
}

function PreCacheReferences()
{	//never called - here to force precaching of meshes like in any normal UT game...
	//continuing mission in attempt to reduce lag as much as possible
	Spawn(Class'UnrealShare.BruteCarcass');
	Spawn(Class'UnrealShare.LesserBruteCarcass');
	Spawn(Class'UnrealShare.CowCarcass');
	Spawn(Class'UnrealShare.DevilfishCarcass');
	Spawn(Class'UnrealShare.FlyCarcass');
	Spawn(Class'UnrealI.GassiusCarcass');
	Spawn(Class'UnrealI.KrallCarcass');
	Spawn(Class'UnrealShare.MantaCarcass');
	Spawn(Class'UnrealI.MercCarcass');
	Spawn(Class'UnrealShare.NaliCarcass');
	Spawn(Class'UnrealI.PupaeCarcass');
	Spawn(Class'UnrealShare.CreatureCarcass');
	Spawn(Class'UnrealShare.SkaarjCarcass');
	Spawn(Class'UnrealI.TrooperCarcass');
	Spawn(Class'UnrealShare.SlithCarcass');
	Spawn(Class'UnrealShare.TentacleCarcass');
	Spawn(Class'MonsterHunt.RockTentacleCarcass');
	Spawn(Class'MonsterHunt.WaterTitanCarcass');
	Spawn(Class'MonsterHunt.LavaSlithCarcass');
	Spawn(Class'MonsterHunt.LavaTitanCarcass');
	Spawn(Class'UnrealI.WarlordCarcass');
	Spawn(Class'Unrealshare.CreatureChunks');
	Spawn(class'ExCreatureCarcass');
	Spawn(class'ExCreatureChunks');

	//Reinforce Defaults
	spawn(class'TMale1');
	spawn(class'TMale2');
	spawn(class'TFemale1');
	spawn(class'TFemale2');
	spawn(class'TBoss');
	spawn(class'ImpactHammer');
	spawn(class'Translocator');
	spawn(class'Enforcer');
	spawn(class'UT_Biorifle');
	spawn(class'ShockRifle');
	spawn(class'PulseGun');
	spawn(class'Ripper');
	spawn(class'Minigun2');
	spawn(class'UT_FlakCannon');
	spawn(class'UT_Eightball');
	spawn(class'SniperRifle');
	spawn(class'WarheadLauncher');
	//Now Let's see the options for old weaponry
	//These are in fact meshes used - originals
	Spawn(class'UnrealShare.ASMD');
	Spawn(class'UnrealShare.AutoMag');
	Spawn(class'UnrealShare.DispersionPistol');
	Spawn(class'UnrealShare.Eightball');
	Spawn(class'UnrealI.FlakCannon');
	Spawn(class'UnrealI.GESBioRifle');
	Spawn(class'UnrealI.Minigun');
	Spawn(class'UnrealI.QuadShot');
	Spawn(class'MH2_NS_V2.MHquadshot');
	Spawn(class'UnrealI.Razorjack');
	Spawn(class'UnrealI.Rifle');
	Spawn(class'UnrealShare.Stinger');
//	Spawn(class'olweapons.OLquadshot'); //End of a stupid story, LOL.
}

function bool IsOnTeam(Pawn Other, int TeamNum)	//Added
{
	if ( Other.bIsPlayer && Other.PlayerReplicationInfo != None
	&& Other.PlayerReplicationInfo.Team == TeamNum )
		return true;
	return false;
}

function float GameThreatAdd(Bot aBot, Pawn Other) //Added
{
	local float Threaten;
	local bool bPowerThreat;
	Threaten = 0;
	if ( Other.IsA('ScriptedPawn') && ScriptedPawn(Other).Event != '' )
	{
		Threaten = 10;
		bPowerThreat = True;
	}
	if (!bPowerThreat)
	{
		if ( Other.IsA('ScriptedPawn') && !Other.IsA('Cow') && !Other.IsA('Nali') && Other.Health > 0)
			Threaten = FClamp(3000/VSize(Other.Location-aBot.Location),1,10);
	}
	if ( Other.IsA('TeamCannon') || (Other.Location.Z - aBot.Location.Z > 500) )
		Threaten = -1;

//	log ("Game threat for "$aBot.GetHumanName()$" is "$Threaten$ " at "$Other.GetHumanName());
	return Threaten;
}

function byte PriorityObjective(Bot aBot) //Added
{
	local ScriptedPawn S;

	if ( aBot.Weapon != None )
	{
		if ( aBot.Weapon.AIRating < 0.3 )
			return -1;
		else
			return 0.5;
	}
	return 0;
}

function byte AssessBotAttitude(Bot aBot, Pawn Other)	//Added
{
	local name MState;

	MState=Other.GetStateName();

	if ( !ValidSight(Other,aBot) || MState == 'Sitting' || !Other.bBlockActors )
		return 2;
	else if ( ValidSight(Other,aBot) && !Other.bHidden && MState != 'Sitting' )
	{
		if ( ( Other.bIsPlayer && Other.PlayerReplicationInfo != None && Other.PlayerReplicationInfo.Team == aBot.PlayerReplicationInfo.Team ) || Other.IsA('Nali') || Other.IsA('Cow') )
			return 3;
		if ( Other.IsA('TeamCannon') && TeamCannon(Other).MyTeam==0 )
			return 3;
		if ( !Other.bIsPlayer && Other.CollisionHeight < 75 )
			return 1;
		if ( !Other.bIsPlayer && Other.CollisionHeight >= 75 )
			return 0;
	}
	else return super(DeathMatchPlus).AssessBotAttitude(aBot, Other);
}
/*
We had initially an option to decrease score for killing friendly creatures but nothing to stop a bot
to kill them. Anyway some idiots mappers used them triggered to open ways or end maps.
So, will be a must to kill them, but I won't be agree to decrease score for completing mission, :P, asholes...
Check ScoreKill as well...
*/

function AddDefaultInventory( pawn PlayerPawn ) //Screwed
{
	bUseTranslocator = False;
	if (!bStartedHunt || bGameEnded)
		return;
	Super(GameInfo).AddDefaultInventory(PlayerPawn); //Directly in subject, wheeew !!!
}

event InitGame( string Options, out string Error ) //Screwed
{
	local string InOpt, LeftOpt;
	local int i;
	local int pos;

// This lot is a crappy hack to get Tournament mode
// to work... Hacked from DeathMatchPlus
// - Nelsona - Note: You should hack some Assault and/or CTF codes, options for A.I. are a real mess
// I'll show you some crappy hack right in here, not crappy, just personal manure

// Start timer related problems FIRST
	RemainingTime = 60 * TimeLimit;
	SetGameSpeed(GameSpeed);
//==========
//Section power tweaking
	if (bDoSpawnSpamFix)
	{
		ConsoleCommand("set SpawnPoint bStatic False");
		ConsoleCommand("set SpawnPoint bNoDelete False");
	}
// More goes in here
	if (bDoSpawnSpamFix)
		DoSpawnfix(); //Now suck well
	DoTheDirt(); //This is only for my fun - Client will be normal, but my server won't host craps
	ConsoleCommand("set PathNode bStatic False");
	ConsoleCommand("set PathNode bNoDelete False");
	ConsoleCommand("set Inventory bNoDelete False");
	ConsoleCommand("set Inventory bStatic False");
	ConsoleCommand("set Pawn bNoDelete False");
	ConsoleCommand("set Pawn bStatic False");
	ConsoleCommand ("set ScriptedPawn bGameRelevant False"); //Allow me to manage things
	ConsoleCommand ("set ScriptedPawn TeamTag $TT");
	ConsoleCommand ("set PathNode bPlayerOnly False");
	ConsoleCommand ("set PathNode NetUpdateFrequency 1.000000"); //Less useful updating - is bStatic anyway and cannot be screwed easily
	ConsoleCommand ("set PathNode RemoteRole ROLE_None"); //Really I don't care about that RemoteRole
	ConsoleCommand ("set PathNode bStatic True");
	ConsoleCommand ("set PathNode bNoDelete True");
	ConsoleCommand ("set WarHeadAmmo AmmoAmount 1");
//==========
	Super(GameInfo).InitGame(Options,Error);
	MaxTeams = 2;
	TimeLimit = GetIntOption( Options, "TimeLimit", TimeLimit );
	// Here some byte was set, I'm so glaaaad :D, Yaay !
	//Checking stupid values. Bullshits aren't accepted...
	if (SkillMonster > 7) SkillMonster = 7;
	if (SkillMonster < 1) SkillMonster = 1; //Not accept 0 value :P.
	if ( SkillMonster == 1 )
		Difficulty = 0;
	if (SkillMonster == 2 || SkillMonster == 3)
		Difficulty = 1;
	if (SkillMonster == 4 || SkillMonster == 5)
		Difficulty = 2;
	if (SkillMonster == 6 || SkillMonster == 7)
		Difficulty = 3;
/*
These are history, I won't use them anyway, in low gravity a pupae is really stupid
Only a dumb-ass will use these. Is time to leave things normal.
	for (M = BaseMutator; M != None; M = M.NextMutator)
	{
		if (M.class == class'Botpack.LowGrav')
		{
			last.NextMutator = M.NextMutator;
			M.Destroy();
			M = last;
		}
		if (M.class == class'Botpack.InstaGibDM')
		{
			last.NextMutator = M.NextMutator;
			M.Destroy();
			M = last;
		}
	}
*/
	FragLimit = 0; //LOL. What is for this one ?
	MaxCommanders = 0; //Really ? Need craps ? Where are used these ?
	InOpt = ParseOption( Options, "CoopWeaponMode");
	if ( InOpt != "" ) bCoopWeaponMode = bool(InOpt);
	IDnum = -1;
/*
	IDnum = GetIntOption( Options, "Tournament", IDnum ); //No need this
	if ( IDnum > 0 )
	{
		bRatedGame = true;
		TimeLimit = 0;
		RemainingTime = 0;
	}
*/
	if ( Level.NetMode == NM_StandAlone )
	{
		bRequireReady = true;
		CheckReady();
	}
	if ( Level.NetMode == NM_StandAlone )
	{
		bRequireReady = true;
		CountDown = 1;
	}
	if ( !bRequireReady && (Level.NetMode != NM_Standalone) )
	{
		bRequireReady = true;
		bNetReady = true;
	}
	bJumpMatch = False;
	bNoMonsters = False;
	bNoTeamChanges = True;
	bBalanceTeams = False;
	bPlayersBalanceTeams = False;
	bSpawnInTeamArea = True; //Probably we have great things in here
	bCanChangeSkin = True;	//By default, :P
//	bLocalLog = False;	//Assuming we have a better LogFileClass :|
	bWorldLog = False;	//Bla bla too much talk, keep bandwidth clean because you piss me off.
}

function Timer() //Screwed - just skip Domination chapter
{
	if (!bSpeedRefresh)
	{
		SetGameSpeed(GameSpeed);
		bSpeedRefresh=True;
	}
	Super(DeathMatchPlus).Timer();
}

function bool SetEndCams(string Reason)
{
	local TeamInfo BestTeam;
	local int i;
	local pawn P, Best;
	local PlayerPawn player;
	local bool bGood;
	local ScriptedPawn S;
	local CreatureCarcass C;
	local ThingFactory T;
	local SpawnPoint SP;

	bGood = True;

	// find individual winner
	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
		if ( P.bIsPlayer && ((Best == None) || (P.PlayerReplicationInfo.Score > Best.PlayerReplicationInfo.Score)) )
			Best = P;

	if ( Reason == "No Hunters" ) //Is possible to have this if you lost all lives... He, he, can be cheated, :D, :P
		{
		bGood = False;
		GameEndedMessage = "Hunting party eliminated!";
		}

	if ((RemainingTime == 0) && (TimeLimit >= 1))
		{
		bGood = False;
		GameReplicationInfo.GameEndedComments = TimeOutMessage;
		}
	else
		GameReplicationInfo.GameEndedComments = GameEndedMessage;
		EndTime = Level.TimeSeconds + 3.0;

	for ( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		player = PlayerPawn(P);
		if (P != None && P.IsA('ScriptedPawn'))
		{
			ScriptedPawn(P).Enemy = None;
			ScriptedPawn(P).Hated = None;
			ScriptedPawn(P).bHunting = False;
			ScriptedPawn(P).Target = None;
			ScriptedPawn(P).MoveTarget = None;
			P.HidePlayer();
			P.Style = STY_Translucent;
		}
		if (!P.IsA('TournamentPlayer'))
			P.GotoState('GameEnded');
		P.SetLocation(P.Location);
		P.Velocity.X = 0;
		P.Velocity.Y = 0;
		P.Velocity.Z = 0;
		if ( Player != None )
		{
			player.bBehindView = true;
			if ( Player == Best )
				Player.ViewTarget = None;
			else
				Player.ViewTarget = Best;
			if (!bTutorialGame)
				PlayWinMessage(Player, bGood);
			Player.GotoState('GameEnded');
			Player.ClientGameEnded();
		}
	}
	if (!bGarbRemoved)
	{
		log ("Game seems to be ended, destroying garbage pawns and other useless actors remained...");
		foreach AllActors (class 'CreatureCarcass', C)
		{
			if (C != None && (!C.bStatic && !C.bNoDelete))
			C.GoToState('Corroding','');
		}
		foreach AllActors (class 'ThingFactory', T)
		{
			if (T != None)
			{
				T.MaxItems = 0;
				T.capacity = 0;
				T.GotoState('Finished');
			}
		}
		log ("Craps removed, start computing stats ...");
		CalcEndStats();	//I think next time is your turn to be loved...
		bGarbRemoved = True; //For maps with player and bots under trigger to not repeat craps - also solved Ending trigger
	}
	return true;
}

function PlayStartUpMessage(PlayerPawn NewPlayer)	//This is for that Green Message when player is joining to server
{
	local int i;
	local color Green, DarkGreen;

	NewPlayer.ClearProgressMessages();

	Green.G = 255;
	Green.B = 128;
	DarkGreen.G = 200;
	DarkGreen.B = 64;

	NewPlayer.SetProgressColor(Green, i);

	NewPlayer.SetProgressMessage(GameName, i++);
	if ( bRequireReady && (Level.NetMode != NM_Standalone) )
	{
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(TourneyMessage, i++);
	}
	else
	{
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(StartUpMessage, i++);
	}

	if ( Level.NetMode == NM_Standalone )
	{
		NewPlayer.SetProgressColor(Green, i);
		NewPlayer.SetProgressMessage(SingleWaitingMessage, i++);
	}
}

event playerpawn Login
(
	string Portal,
	string Options,
	out string Error,
	class<playerpawn> SpawnClass
)
{
	local PlayerPawn	NewPlayer, TestPlayer;
	local string		OverrideClass;
	local class<PlayerPawn> SpecClass;
	local string		InVoice;
	local NavigationPoint StartSpot;

	if ( (Level.NetMode != NM_Standalone) && (NumCommanders >= MaxCommanders) && ClassIsChildOf(SpawnClass, class'Commander') )
	{
		Error="Max commanders "$MaxCommanders$" exceeded";
		return None;
	}
	
	if ( !bRatedGame )
	{
		if ( !bDisallowOverride )
		{
			OverrideClass = ParseOption ( Options, "OverrideClass" );
			if ( OverrideClass != "" )
			{
				SpecClass = class<PlayerPawn>(DynamicLoadObject(OverrideClass,class'Class'));
				if ( (SpecClass != None) && ClassIsChildOf( SpecClass, class'CHSpectator') )
					SpawnClass = SpecClass;
			}
		}
		if ( ClassIsChildOf(SpawnClass, class'Spectator') )
		{
			if ( !ClassIsChildOf( SpawnClass, class'CHSpectator') )
				SpawnClass = class'CHSpectator';
		}
		else if ( !ClassIsChildOf(SpawnClass, class'TournamentPlayer') )
			SpawnClass = DefaultPlayerClass;
	}
	else if ( !ClassIsChildOf(SpawnClass, class'TournamentPlayer') )
		SpawnClass = DefaultPlayerClass;

	NewPlayer = Super(GameInfo).Login(Portal, Options, Error, SpawnClass);

	if ( NewPlayer != None )
	{
		if ( !NewPlayer.IsA('Spectator') )
		{
			InVoice = ParseOption ( Options, "Voice" );
			if ( InVoice != "" )
				NewPlayer.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject(InVoice, class'Class'));
			if ( NewPlayer.PlayerReplicationInfo.VoiceType == None )
				NewPlayer.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject(NewPlayer.VoiceType, class'Class'));
			if ( NewPlayer.PlayerReplicationInfo.VoiceType == None )
				NewPlayer.PlayerReplicationInfo.VoiceType = class<VoicePack>(DynamicLoadObject("Botpack.VoiceMaleOne", class'Class'));
		}
		if ( bRatedGame )
			NewPlayer.AirControl = 0.35;
		else
			NewPlayer.AirControl = AirControl;
		if ( Left(NewPlayer.PlayerReplicationInfo.PlayerName, 6) == DefaultPlayerName )
		{
			if (Level.Game.WorldLog != None)
				Level.Game.WorldLog.LogSpecialEvent("forced_name_change", NewPlayer.PlayerReplicationInfo.PlayerName, NewPlayer.PlayerReplicationInfo.PlayerID, DefaultPlayerName$NumPlayers);
			ChangeName( NewPlayer, (DefaultPlayerName$NumPlayers), false );
		}
		NewPlayer.bAutoActivate = True;
		if ( (bGameEnded || (bRequireReady && (CountDown > 0))) && !NewPlayer.IsA('Spectator') )
			NewPlayer.PlayerRestartState = 'PlayerWaiting';
		else
			NewPlayer.PlayerRestartState = NewPlayer.Default.PlayerRestartState;

		if ( NewPlayer.IsA('TournamentPlayer') )
		{
			TournamentPlayer(NewPlayer).StartSpot = LastStartSpot;
			if ( NewPlayer.IsA('Commander') )
				NumCommanders++;
		}
	}

	// Section TeamGamePlus almost totally skipped
	if ( newPlayer == None)
		return None;

		PlayerTeamNum = NewPlayer.PlayerReplicationInfo.Team;
	if (bUseLive)	//Grr, continue to piss me off...
		if ( (NewPlayer != None) && !NewPlayer.IsA('Spectator') )
			NewPlayer.PlayerReplicationInfo.Deaths = MonsterReplicationInfo2(GameReplicationInfo).Live;
	CountHunters();	//Yea, buy a counter, I think we have already some NumPlayers at gameinfo but... heck.
	return newPlayer;
}

function bool RestartPlayer( pawn aPlayer )
{
	local NavigationPoint startSpot;
	local bool foundStart;
	local Pawn P;

	if (MonsterReplicationInfo2(GameReplicationInfo).bUseLive) //No really comment, um, oh, yes - retarded option
	{
		if( bRestartLevel && Level.NetMode!=NM_DedicatedServer && Level.NetMode!=NM_ListenServer )
			return true;

		if ( aPlayer.PlayerReplicationInfo.Deaths < 1 )
		{
			BroadcastMessage(aPlayer.PlayerReplicationInfo.PlayerName$" has been lost!", true, 'MonsterCriticalEvent');
			For ( P=Level.PawnList; P!=None; P=P.NextPawn )
			{
				if (!P.bIsPlayer || P.PlayerReplicationInfo == None)
					continue;
				if ( P.bIsPlayer && (P.PlayerReplicationInfo.Deaths >= 1) ) //Only a loser is lost, a smart one is not lost :P
					P.PlayerReplicationInfo.Deaths += 0.00001;		//Maybe 0.000000001278372376453 :D
			}
			if ( aPlayer.IsA('Bot') )
			{
				aPlayer.PlayerReplicationInfo.bIsSpectator = true;
				aPlayer.PlayerReplicationInfo.bWaitingPlayer = true;
				aPlayer.GotoState('GameEnded');
				return false;
			}
		}
		startSpot = FindPlayerStart(None, 255);
		if( startSpot == None )
			return false;
		foundStart = aPlayer.SetLocation(startSpot.Location);
		if( foundStart )
		{
			startSpot.PlayTeleportEffect(aPlayer, true);
			aPlayer.SetRotation(startSpot.Rotation);
			aPlayer.ViewRotation = aPlayer.Rotation;
			aPlayer.Acceleration = vect(0,0,0);
			aPlayer.Velocity = vect(0,0,0);
			aPlayer.Health = aPlayer.Default.Health;
			aPlayer.ClientSetRotation( startSpot.Rotation );
			aPlayer.bHidden = false;
			aPlayer.DamageScaling = aPlayer.Default.DamageScaling;
			aPlayer.SoundDampening = aPlayer.Default.SoundDampening;
			if ( aPlayer.PlayerReplicationInfo.Deaths < 1 )
			{
				aPlayer.bHidden = true;
				aPlayer.PlayerRestartState = 'PlayerSpectating';
			} 
			else
			{
				aPlayer.SetCollision( true, true, true );	//Hm, interesting anyway...
				AddDefaultInventory(aPlayer);			//Wow, what inventory ? Will see... 
			}
		}
		return foundStart;
	}
	else 
		return Super.RestartPlayer(aPlayer);
	CountHunters();
}

function bool CanTranslocate(Bot aBot) //Directive added
{
	Super(DeathMatchPlus).CanTranslocate(aBot);
}

function CalcEndStats() //Oops
{
//LOL ! Next time stop shouting as retard !!! Calc end.... Shite
}

function Logout(pawn Exiting)
{
	local Projectile Pr;
	local bool logged;
	foreach AllActors (class 'Projectile', Pr)
	{
		if ( Pr != None )
		{
			if (Pr.Instigator == Exiting)
			{
				if (!logged)
					log (Exiting.GetHumanName()$" left server, removing trash behind...");
				logged = True;
				Pr.bReplicateInstigator = False;
				Pr.Instigator = None;
				Pr.Destroy();
			}
		}
	}
	if (!Exiting.bIsPlayer || Exiting.PlayerReplicationInfo == None )
		return;
	Super(DeathMatchPlus).Logout(Exiting);
	if ( Exiting.IsA('Spectator') || Exiting.IsA('Commander') )
		return;
	CountHunters(); //Cough
	logged = False;
}

function CheckEndGame()		//If a dude is losing lives will be removed from party, too bad
{
	local Pawn PawnLink;
//	local int StillPlaying;
//	local bool bStillHuman;
	local bot B, D;

	if ( bGameEnded )
		return;

	LivePpl = 0;
	PlainPpl = 0;

	for ( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.nextPawn )
	{
		if (!PawnLink.bIsPlayer || PawnLink.PlayerReplicationInfo == None )
			continue;
		if ( PawnLink.bIsPlayer )
		{
			if ( ( PawnLink.PlayerReplicationInfo.Deaths >= 1 ) && 
				!PawnLink.PlayerReplicationInfo.bIsSpectator )
				LivePpl ++;
			if ( PawnLink.IsA('PlayerPawn') &&
				(PawnLink.PlayerReplicationInfo.Deaths >= 1) )
				PlainPpl ++;
		}
	}
	if ( LivePpl < 1 )
		EndGame("No Hunters");

	else if ( PlainPpl < 1 && LivePpl > 0 ) //Only if human(s) missing and is still somebody here.
	{
		for ( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn )
		{
			B = Bot(PawnLink);
			if ( (B != None) && (B.Health > 0) )
				B.SetOrders('Freelance',None,true);
		}
	}
}

function Killed( pawn killer, pawn Other, name damageType )
{
	local Scriptedpawn S;
	local Pawn P;

	if ( Other == None )
	{
		log("Bork: Something seems unexistent calling function Killed. Will ignore with return.");
		return;
	}
	if ( Killer != None )	//Modifications added for avoid cheating bUseLives option (I don't really need it)
	{						//See also Scorekill for this fix (is about suicide with a few HP to save a life)
		if ( !bFirstBlood )
		if ( Killer.bIsPlayer && (Killer != Other) && Killer.PlayerReplicationInfo != None )
		{
			bFirstBlood = True;
			BroadcastLocalizedMessage( class'FirstBloodMessage', 0, Killer.PlayerReplicationInfo );
		}
		bFirstBlood = True;
		if ( Other.bIsPlayer && Killer == Other && Other.PlayerReplicationInfo != None )
		{
			if (Killer.Spree > 0)
				Killer.Spree = 0;
			Other.PlayerReplicationInfo.Score -= 100;
			Other.PlayerReplicationInfo.Deaths -= 2;
			CheckEndGame();
		}

		if ( Killer.bIsPlayer && (Killer != Other && Other.bIsPlayer && Other.PlayerReplicationInfo != None) )
		{
			if (Killer.Spree > 0)
			Killer.Spree = 0;
			if ( DamageType != 'crushed' && Killer.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team )
			{
				if (Killer.PlayerReplicationInfo.Score > 10)
					Killer.PlayerReplicationInfo.Score /= 5; //More nasty to kill players
				else
					Killer.PlayerReplicationInfo.Score -= 500; //Siclair Spectrum > R Tape Loading error :P
				Killer.Died(Killer,'Suicided',Killer.Location);
			}
			Other.PlayerReplicationInfo.Deaths -= 1;
		}

		if ( !Killer.bIsPlayer || Killer.PlayerReplicationInfo == None || Killer.IsA('StartionaryPawn') )
		{
			if ( Other.bIsPlayer && Other.PlayerReplicationInfo != None && Killer != Other)
			{
				if (Other.PlayerReplicationInfo.Score > 10)
					Other.PlayerReplicationInfo.Score *= Pen;
				else
					Other.PlayerReplicationInfo.Score -= 10;
				Other.PlayerReplicationInfo.Deaths -= 1;
				if (Other.Spree > 0)
					Other.Spree = 0;
				CheckEndGame();
			}
			if ( !Other.bIsPlayer || Other.PlayerReplicationInfo == None || Other.IsA('StationaryPawn'))
			{
				if ( Killer != Other )
				{
					BroadcastMessage( Killer.GetHumanName()@" killed "$Other.GetHumanName() );
					if ( ScriptedPawn(Killer) != None && ScriptedPawn(Killer).Orders == '' )
						ScriptedPawn(Killer).GotoState('Waiting');
					return;
				}
				if (Killer == Other)
				{
					BroadcastMessage(Killer.GetHumanName()@"was killed by self stupidity.");
					return;
				}
			}
		}
		if ( Killer != Other && ( Other.PlayerReplicationInfo == None || !Other.bIsPlayer ) || Other.IsA('StationaryPawn') )
			BroadcastMessage(Killer.GetHumanName()@"killed"$Other.GetHumanName());
	}
	else
	{
		if ( !Other.bIsPlayer || Other.PlayerReplicationInfo == None || Other.IsA('StationaryPawn') )
		{
			if (DamageType == 'Exploded')
				BroadcastMessage(Other.GetHumanName()@" had a strange explosion.");
			else if (DamageType == 'Burned')
				BroadcastMessage(Other.GetHumanName()@" was burned by a hostile environment.");
			else if (DamageType == 'Corroded')
				BroadcastMessage(Other.GetHumanName()@" was corroded by a hostile fluid.");
			else if (DamageType == 'Mortared')
				BroadcastMessage(Other.GetHumanName()@" was blown up by a mortar.");
			else if (DamageType == 'Drowned')
				BroadcastMessage(Other.GetHumanName()@" forgot to come up for air.");
			else if (DamageType == 'Fell')
				BroadcastMessage(Other.GetHumanName()@" crashed falling.");
			else if (DamageType == 'Eradicated')
				BroadcastMessage(Other.GetHumanName()@" has been eradicated.");
			else if (DamageType == 'Suicided')						//Can be ? Movers ? Others ?
				BroadcastMessage(Other.GetHumanName()@" suffered a self damage.");
			else if (DamageType == 'Crushed')
				BroadcastMessage(Other.GetHumanName()@" died crushed.");
			else
				BroadcastMessage(Other.GetHumanName()@" died.");
			if ( ScriptedPawn(Other) != None && ScriptedPawn(Other).CarcassType != None )
				ScriptedPawn(Other).SpawnGibbedCarcass();
			Other.Destroy();
			return;
		}
		if ( Other.PlayerReplicationInfo != None && DamageType == 'SpecialDamage')
		{
			if (SpecialDamageString == "")
				BroadcastMessage(Other.GetHumanName()@"died.");
			else
				BroadcastMessage(Other.GetHumanName()@"died"@SpecialDamageString);
			Other.DieCount++;
			Other.PlayerReplicationInfo.Score -= 1;
			Other.PlayerReplicationInfo.Deaths -= 1;
			Other.Spree = 0;
			CheckEndGame();
			return;
		}

		if ( Other.bIsPlayer && Other.PlayerReplicationInfo != None )
		{
			if ( Other.Spree > 0 )
				Other.Spree = 0;
			Other.PlayerReplicationInfo.Score -= 100;
			Other.PlayerReplicationInfo.Deaths -= 2;	//Have to check this well to gain right values
														//It looks like works properly but something need a wrapping
														//I don't like the deal with 2. This is that lives thing deal
			Super.Killed(Killer, Other, damageType);	//Here comes UT...
			CheckEndGame();
			return;
		}
	}
	Super(GameInfo).Killed(Killer, Other, damageType);
}

function ScoreKill(pawn Killer, pawn Other)
{
	local Pawn P;
	local ScriptedPawn S;
	local int ph;
	local string damageType;
	if ( Killer != None )
	{
//		if ( Killer.Isa('StationaryPawn') ) return;
		if (!Other.IsA('ScriptedPawn')) return;

// =========================================================================
// Score depending on the max health of the monster killed.

		// Lose points for killing innocent creatures. Shame ;-)
		// Really ? Your stupid joke will be ended today, done.
		// If you love innocent creatures why need a bot to kill them ? Dumbass !

		if ( Killer.bIsPlayer && Killer.PlayerReplicationInfo != None && Other.IsA('ScriptedPawn'))
		{
			ph = ScriptedPawn(Other).Default.Health;
			if (Other.IsA('Nali') || Other.IsA('Cow'))
			{
				Killer.PlayerReplicationInfo.Score += 0.02*ph; // Bullshits ? Give me a break. Now they are fixed.
			}
			else if (ScriptedPawn(Other).bIsBoss)
			{
				Killer.PlayerReplicationInfo.Score += 0.06*ph; // Will be Nice
			}
			else
			{
				Killer.PlayerReplicationInfo.Score += 0.04*ph; // Really nice
			}
		}
	}
	CountHunters();
	BaseMutator.ScoreKill(Killer, Other);
}

event PostLogin( playerpawn NewPlayer )
{
	Super(DeathMatchPlus).PostLogin(NewPlayer);

/*
	Manure to set color removed succesfully
	if ( Level.NetMode != NM_Standalone ) //LOLZ to red color
		NewPlayer.ClientChangeTeam(NewPlayer.PlayerReplicationInfo.Team);
*/
}

function NavigationPoint FindPlayerStart( Pawn Player, optional byte InTeam, optional string incomingName )
{
	local PlayerStart Dest, Candidate[32], Best;
	local float Score[32], BestScore, NextDist;
	local pawn OtherPlayer;
	local int i, num;
	local Teleporter Tel;
	local NavigationPoint N;
	local byte Team;

	Team = 0;
	
	if ( bStartMatch && (Player != None) && Player.IsA('TournamentPlayer') 
		&& (Level.NetMode == NM_Standalone)
		&& (TournamentPlayer(Player).StartSpot != None) )
		return TournamentPlayer(Player).StartSpot;

	if ( (Player != None) && (Player.PlayerReplicationInfo != None) )
		Team = Player.PlayerReplicationInfo.Team;
	else
		Team = InTeam;

	if( incomingName!="" )
		foreach AllActors( class 'Teleporter', Tel )
			if( string(Tel.Tag)~=incomingName )
				return Tel;

	if ( Team == 255 || Team != 0 )
		Team = 0;

	//choose candidates
	num = 0;
	for ( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
	{
		Dest = PlayerStart(N);
		if ( (Dest != None) && Dest.bEnabled
			&& (!bSpawnInTeamArea || (Team == Dest.TeamNumber)) )
		{
			if (num<32)
				Candidate[num] = Dest;
			else if (Rand(num) < 32)
				Candidate[Rand(32)] = Dest;
			num++;
		}
	}

	if (num == 0 ) //Lol ?
	{
//		log("Playerstart for team"@Team@"not found !");
		foreach AllActors( class'PlayerStart', Dest )
		{
			if (num < 32)
				Candidate[num] = Dest;
			else if (Rand(num) < 32)
				Candidate[Rand(32)] = Dest;
			num++;
		}
		if ( num == 0 )
			return None;
	}
	if (num > 32) 
		num = 32;
	//assess candidates
	for (i=0;i<num;i++)
	{
		if ( Candidate[i] == LastStartSpot )
			Score[i] = -6000.0;
		else
			Score[i] = 4000 * FRand(); //randomize
	}
	
	for ( OtherPlayer=Level.PawnList; OtherPlayer!=None; OtherPlayer=OtherPlayer.NextPawn)	
	{
	if ( !OtherPlayer.bIsPlayer || OtherPlayer.PlayerReplicationInfo == None)
		continue;
	if ( OtherPlayer.bIsPlayer && (OtherPlayer.Health > 0) && !OtherPlayer.IsA('Spectator') && OtherPlayer.PlayerReplicationInfo != None )
			for (i=0; i<num; i++)
				if ( OtherPlayer.Region.Zone == Candidate[i].Region.Zone ) 
				{
					Score[i] -= 1500;
					NextDist = VSize(OtherPlayer.Location - Candidate[i].Location);
					if (NextDist < 2 * (CollisionRadius + CollisionHeight))
						Score[i] -= 1000000.0;
					else if ( (NextDist < 2000) && (OtherPlayer.PlayerReplicationInfo.Team != Team)
							&& FastTrace(Candidate[i].Location, OtherPlayer.Location) )
						Score[i] -= (10000.0 - NextDist);
				}
	}
	BestScore = Score[0];
	Best = Candidate[0];
	for (i=1; i<num; i++)
		if (Score[i] > BestScore)
		{
			BestScore = Score[i];
			Best = Candidate[i];
		}
	LastStartSpot = Best;
	return Best;
}

function AddToTeam( int num, Pawn Other )		//Yea, exactly to Team (not outside :D)
{
	local teaminfo aTeam;
	local Pawn P;
	local bool bSuccess;
	local string SkinName, FaceName;
	num = 0;

	if ( Other == None || Other.PlayerReplicationInfo == None )
	{
		log("Added none to team!!!");
		return;
	}
	if (MaxTeams == 2 || MaxAllowedTeams == 2) //So what ? Let me know if might be a problem ...
	{
	if ( Other != None && Other.PlayerReplicationInfo != None )
	{
		aTeam = Teams[num];
		aTeam.Size++;
		Other.PlayerReplicationInfo.Team = num;
		Other.PlayerReplicationInfo.TeamName = aTeam.TeamName;
		bSuccess = False;
		if ( Other.IsA('PlayerPawn') )
		{
			Other.PlayerReplicationInfo.TeamID = num; //So, team assigned and here is TeamID ? As described above.
//			PlayerPawn(Other).ClientChangeTeam(Other.PlayerReplicationInfo.Team); //No stupid skin changing. Team has been assigned already.
		}
		while ( !bSuccess )
		{
			bSuccess = true;
			for ( P=Level.PawnList; P!=None; P=P.nextPawn )
			{
				if (!P.bIsPlayer || P.PlayerReplicationInfo == None)
					continue;
				if ( P.bIsPlayer && (P != Other) && (P.PlayerReplicationInfo.Team == Other.PlayerReplicationInfo.Team) 
					&& (P.PlayerReplicationInfo.TeamId == Other.PlayerReplicationInfo.TeamId) && Other.PlayerReplicationInfo != None )
				{
					Other.PlayerReplicationInfo.TeamID++;
					bSuccess = False;
				}
			}
		}
		
		if (MonsterReplicationInfo2(GameReplicationInfo).bUseLive)
			Other.PlayerReplicationInfo.Deaths = MonsterReplicationInfo2(GameReplicationInfo).Live;

		if (MonsterReplicationInfo2(GameReplicationInfo).bUseTeamSkin)	//Bla, bla something is missing here anyway
		{
			Other.static.GetMultiSkin(Other, SkinName, FaceName);		//Was always nasty in Network
			Other.static.SetMultiSkin(Other, SkinName, FaceName, num);
		}
	}
	}
}

function StartMatch()
{
	local Pawn P;
	local ScriptedPawn S;

	for (P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		S=ScriptedPawn(P);
		if ( S != None )	//Game has started - We turn back the Hate for humanity, kill players, go, go, go... .
		{					//Of course we don't trigger friendly classes, :P.
			if (!S.IsA('Nali') && !S.IsA('Cow'))
			{
				S.AttitudeToPlayer = ATTITUDE_Frenzy;
			}
		}
	}

	CountHunters();
	if (NumPts > 0)
		BroadcastMessage("Map seems to have"@NumPts@"WayPoints.");
	if (TN < 20)
		BroadcastMessage("Map seems to have only"@TN@"Pathnodes. We don't expect more Relics and/or Bot Support.");
	bStartedHunt = True;
	super.StartMatch();
	log ("MH2_NS_V2.MonsterHunt game-mod has been initialized and started"); //Yep, let's see the start.
}

function CountHunters()
{
	TotalHunters = NumPlayers + NumBots; //Eh, sometimes I'm a loser too, why I didn't noticed this ?
							//Simple shit without building PawnList each second only for hunters.
							//I think I have some speed now :D.
	MonsterReplicationInfo2(GameReplicationInfo).Hunter = TotalHunters;
}

function ClearOrders(Pawn Leaving) //reservation, no problem next time will treat it as needed
{
	local Pawn P;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.IsA('Bot') && (Bot(P).OrderObject == Leaving) )
			Bot(P).SetOrders('Attack', None, True);
}

function Actor SetDefenseFor(Bot aBot) //Screwed
{
//Override...
}

function PickAmbushSpotFor(Bot aBot)
{
	local NavigationPoint N;

	for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
		if ( N.IsA('Ambushpoint') && !N.taken )
		{
			if ( aBot.Orders == 'Defend' )
			{
				if ( N.IsA('DefensePoint') && (DefensePoint(N).team == aBot.PlayerReplicationInfo.team) )
				{
					if ( (DefensePoint(aBot.Ambushspot) == None)
						|| (DefensePoint(N).priority > DefensePoint(aBot.Ambushspot).priority) )
						aBot.Ambushspot = Ambushpoint(N);
					else if ( (DefensePoint(N).priority == DefensePoint(aBot.Ambushspot).priority)
						&& (FRand() < 0.4) ) 
						aBot.Ambushspot = Ambushpoint(N);
				}		
				else if ( (DefensePoint(aBot.AmbushSpot) == None)
						&& (VSize(N.Location - aBot.OrderObject.Location) < 1500)
						&& FastTrace(aBot.OrderObject.Location, N.Location)
						&& ((aBot.Ambushspot == None) || (FRand() < 0.5)) )
							aBot.Ambushspot = Ambushpoint(N);
			}
			else if ( (aBot.AmbushSpot == None)
				|| (VSize(aBot.Location - aBot.Ambushspot.Location)
					 > VSize(aBot.Location - N.Location)) )
				aBot.Ambushspot = Ambushpoint(N);
		}
}

// This one is pretty big. But won't mess speed if 0 Bots are added.
// Bot calls this one, it doesn't get called other way.
function bool FindSpecialAttractionFor(Bot aBot) //Almost completely reworked
{
	local Pawn P;
	local Actor MHPath;
	local ScriptedPawn S;
	local bool bFound, foundtarget, bDecoShooting, bLockedAndLoaded;
	local NavigationPoint N, PN;
	local NsWayPoint WP;
	local NsWayPoint NextPoint;
	local MonsterEnd2 E;
	local int aPath;
	local name gstate;
	local Decoration D;
	local string Heavy, Msg;

	if ( aBot.Health < 1 )
	{
		aBot.GotoState('GameEnded');
		return false;
	}
	if ( aBot.LastAttractCheck == Level.TimeSeconds )
		return false;
	if ( abot.Health > 2 && !aBot.bHidden ) //Okay, sometimes unarmed (regen timing issue ?) and so idiot in water ???
	{
		if ( aBot.Weapon == None && aBot.PlayerReplicationInfo.Team == 0 )	//Triggered death = health 1
			RestartPlayer(aBot);											//Regen will keep going messing up with roaming
																			//Perform restart - do not mock my console
		if ( aBot.Region.Zone.bWaterZone )	//WTF is wrong, why are you running in place in water since you have to mind mission ???? Physics ???
		{
			if ( aBot.Physics != PHYS_Swimming )
				aBot.SetPhysics(PHYS_Swimming);
		}
	}
	foreach AllActors(class 'Pawn', P)
//	for (P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		S = ScriptedPawn(P);
		if ( S != None && S.Health >= 1 )
		{
		if (S.IsA('Nali') || S.IsA('Cow') || VSize(S.Location - aBot.Location) > S.SightRadius*0.95) //I think is still too much
	            continue;
		if ((!S.Region.Zone.bWaterZone && !aBot.Region.Zone.bWaterZone )
			 || (aBot.Region.Zone.bWaterZone && !S.Region.Zone.bWaterZone && S.bHasRangedAttack)
			 || (!aBot.Region.Zone.bWaterZone && S.Region.Zone.bWaterZone && S.bHasRangedAttack)
			 || (S.Region.Zone.bWaterZone && aBot.Region.Zone.bWaterZone))
//			if ( S.LineOfSightTo(aBot) )
			if ( ValidSight(S,aBot)/*FastTrace(S.Location,aBot.Location)*/)
			{
				if (S.Enemy == None || ( S.Enemy != None && FRand() > 0.7 && VSize(S.Enemy.Location - S.Location) > VSize ( S.Location - aBot.Location ) ))	//Monsters need to attack if no enemy or random switching through hunters
				{																//but not very often
					gstate = S.GetStateName();
					if ( !S.IsInState('Attacking') && gstate != 'Sitting' && gstate != 'Teleporting')
					{
						S.Hated = aBot;
						S.Enemy = aBot;
						S.Target = aBot;
						S.LastSeenPos = aBot.Location;
						S.GoToState('Attacking');
					}
				}
				if ( (( FRand() > 0.8 && aBot.Enemy != None && aBot.Enemy != S ) || aBot.Enemy == None) && gstate != 'Sitting' )
					aBot.Enemy = S;
			}
		}
	}

	aBot.LastAttractCheck = Level.TimeSeconds;
	if ( bHaveTeleports ) //Small tweak against telefragging
	if ( aBot.Enemy == None || (aBot.Enemy != None && !aBot.LineOfSightTo(aBot.Enemy)))
	{
//		log ("Test telefragging by "$aBot.GetHumanName());
		for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
		{
			if ( VSize(N.Location-aBot.Location) > 600 ) continue;
			if ( N != None && N.IsA('Teleporter')
			&& Teleporter(N).bEnabled
			&& FastTrace(aBot.Location,N.Location)
			&& Teleporter(N).URL != "" )
			{
				foreach aBot.VisibleCollidingActors(class 'Pawn', P, 800)
//				for (P=Level.PawnList; P!=None; P=P.NextPawn)
				{
					if ( P == aBot ) continue;
					if ( P != None && P.PlayerReplicationInfo != None )
					{
//						log ("aPawn has "$VSize(N.Location - P.Location));
//						log ("Attractor "$aBot.GetHumanName()$" has "$VSize(N.Location - aBot.Location));
						if ( VSize(P.Velocity) > 100 && aBot.MoveTarget != None
						&& VSize(N.Location - P.Location) < VSize( N.Location-aBot.Location )
						&& FastTrace(N.Location,P.Location)
						&& VSize( N.Location-aBot.Location ) < 600 )
						{
							aBot.MoveTarget = None;
							aBot.Acceleration = vect(0,0,0);
							aBot.CampTime = 1.0;
							aBot.GotoState('Roaming', 'Camp');
							if (aBot.bVerbose)
								log ("Attempt to stop "$aBot.GetHumanName()$" to not telefrag "$P.GetHumanName());
							return False;
						}
					}
				}
			}
		}
	}
//Section Ruin a stupid Box or such
		if ( aBot.Weapon != None && !aBot.Weapon.bMeleeWeapon )
		{
			foreach aBot.VisibleCollidingActors ( class'Decoration',D,950 )
			{
				if ( D != None && !D.bNodelete && !D.bStatic && FastTrace(D.Location,aBot.Location ) && ( aBot.Enemy == None || ( VSize(aBot.Enemy.Location-aBot.Location ) > VSize(D.Location-aBot.Location )) ) &&
				( D.IsA('WoodenBox') || D.IsA('Barrel') || D.IsA('Vase') || D.IsA('Table')|| D.IsA('Chair') || D.IsA('ExCreatureCarcass') )) //Common stupid decos
				{
					Heavy = Caps(D.class);
					if ( ( D.bBlockActors && D.bBlockPlayers && D.bMovable && D.bCollideActors && D.bProjTarget ) || D.IsA('ExCreatureCarcass') ) //Enforce checking separate for carcass
					{
						if (aBot.bVerbose)
						log (aBot.GetHumanName()$": I see a decoration target being "$Heavy );
						aBot.Target = D;
						aBot.DesiredRotation = Rotator(D.Location-aBot.Location);
						bDecoShooting = True;
						break;
					}
				}
			}
			if ( bDecoShooting && aBot.Target != None )
			{
				if (aBot.bVerbose)
					log (aBot.GetHumanName()$": I'm attempting to shoot Decoration "$D);
				aBot.GotoState('Roaming','ShootDecoration');
			}
		}
//	Separate section to attack any other possible enemy
	if (aBot.Enemy != None && ValidSight(aBot.Enemy,aBot) && FRand() > 0.5 )
	{
		aBot.Target = aBot.Enemy;
		if (!aBot.IsInState('Attacking'))
		{
			aBot.GotoState('Attacking');
			return false;
		}
	}
	if ( aBot.IsInState('Fallback') ) //Retreat as needed
		return False;
//Condition to Not hunt without power or... Kamikaze
	bLockedAndLoaded = ( aBot.Weapon != None && ( ( aBot.Weapon.AIRating >= 0.2 && aBot.Health > 30 ) || aBot.Health > 160 ) );
//
/*
	if ( !bDecoShooting && !aBot.IsInState('Roaming') && aBot.Enemy == None && ( aBot.Orders == 'Attack' || aBot.Orders == 'Freelance' ))
	{
		aBot.bNoClearSpecial = True;
		aBot.GotoState('Roaming', 'SpecialNavig');
	}
*/

//********* Section added... Is not the perfect idea but might help, recover Navigation in fields too far from Paths

	if ( ( aBot.Orders == 'Attack' || aBot.Orders == 'Freelance' ) && aBot.Enemy == None && !bDecoShooting)
	{
		if ( aBot.IsInState('Roaming') && !bStupidMap && aBot.MoveTarget == None && !NearANode(aBot) )
		{
			for ( N=Level.NavigationPointList; N!=None; N=N.NextNavigationPoint )
			{
				if ( N != None && N.IsA('Pathnode') )
				{
					aPath = Vsize(N.Location - aBot.Location);
					if ( aPath > 2500)
						continue;
//					GetAxes(aBot.Rotation,X,Y,Z);
					aBot.DesiredRotation = Rotator( N.Location - aBot.Location );
					aBot.SetRotation(aBot.DesiredRotation);
//					aPathDir = (N.Location-aBot.Location)/aPath;
					if ( aPath > 500 && aBot.CanSee(N) && (( !aBot.Region.Zone.bWaterZone && !N.Region.Zone.bWaterZone) || (aBot.Region.Zone.bWaterZone && N.Region.Zone.bWaterZone) ) )
					{
						aBot.Target = N;
						aBot.RoamTarget = N;
						aBot.MoveTarget = N;
						aBot.bCamping = False;
						aBot.MoveTimer = 1.0;
						if (aBot.bVerbose)
							log (aBot.GetHumanName()$": I sorted a PathNode placed at "$aPath$" distance from me having BestPathWeight="$N.BestPathWeight);
						if (aBot.MoveTarget != None)
						{
							SetForcedStateFor(aBot);
							return True;
						}
					}
				}
			//	break;
			}
		}
	}

//********** End of section added...
	if ( !bLockedAndLoaded )
	{
		if ( FRand() > 0.6 )
			return False;
	}
	else
	{
	if ( aBot.Orders == 'Attack' && FRand() > 0.2 &&
	( aBot.Enemy == None || !aBot.LineOfSightTo(aBot.Enemy) && !aBot.Enemy.IsA('StationaryPawn'))
	|| (aBot.Orders == 'Freelance' &&
	( aBot.Enemy == None || !aBot.LineOfSightTo(aBot.Enemy) && !aBot.Enemy.IsA('StationaryPawn'))) && !bDecoShooting )
	{
		if ( MHTarget == None ) //if doesn't exist a target sort one
		{
//			log ("For the moment not exist any target.");
			if ( NumPts > 0 )
			{
				foreach AllActors( class 'NsWayPoint', WP )
				{
					if (!WP.bVisited && (WP.Position == LastPt + 1))
					{
						NextPoint = WP;
						MHTarget = NextPoint;
						NumPts--;
						foundtarget = True;
					}
				}
			}
			if (!foundtarget)
			{
				foreach AllActors (class 'MonsterEnd2', E)
				{
					if (E != None && !foundtarget)
					{
						MHTarget = E;
						foundtarget = True;
					}
				}
			}
			foundtarget = False;
		}
		if ( MHTarget != None ) //Have defined target ? No more Foreach then :|
		{
			if (!fakeorder )
			{
				if ( !bStupidMap )
				{
					Msg = "Oki doki, let's hunt some monsters...";
					for( P=Level.PawnList; P!=None; P=P.nextPawn )
					{
						if ( P != None && P.IsA('TournamentPlayer') )
							P.TeamMessage( aBot.PlayerReplicationInfo,Msg,'TeamSay');
					}
				}
				else
				{
					if ( TN > 0 )
						Msg = "I'm not very sure about this hunt.";
					else
						Msg = "Man, this is a f.....g piece of crap not Map. We don't have any support in here...";

					for( P=Level.PawnList; P!=None; P=P.nextPawn )
					{
						if ( P != None && P.IsA('TournamentPlayer') )
							P.TeamMessage(aBot.PlayerReplicationInfo,Msg,'TeamSay');
					}
				}
				fakeorder = True;
			}
//			log ("Assigned target :"$MHTarget);
			if ( MHTarget.IsA('MonsterEnd2') )
			{
				if ( VSize( MHTarget.Location - aBot.Location ) < 40 )
				{
					aBot.CampTime = 1.0;
					aBot.GotoState('Roaming', 'Camp');
				}
			}
			if ( MHTarget.IsA('NsWayPoint') )
			{
				if ( VSize( MHTarget.Location - aBot.Location ) < 30 )
				{
					return False;
				}
			}
			if ( aBot.ActorReachable(MHTarget) )
			{
				aBot.RoamTarget = MHTarget;
				aBot.MoveTarget = MHTarget;
				bFound = ( aBot.MoveTarget == MHTarget );
			}
			else
			{
//				aBot.MoveTarget = aBot.FindPathTo/*ward*/(MHTarget.Location);
				MHPath = aBot.FindPathTo/*ward*/(MHTarget.Location);
				if ( MHPath != None )
				{
					aBot.MoveTarget = MHPath;
					aBot.Destination = MHPath.Location;
				}
				bFound = ( MHPath != None || aBot.MoveTarget == MHTarget );
			}
			if ( bFound )
			{
				if ( aBot.Enemy != None )
					aBot.bReadyToAttack = true;
				if (!aBot.bCampOnlyOnce
				&& aBot.SpecialPause == 0 )
				{
					SetAttractionStateFor(aBot);
					return true;
				}
			}
			else
			{
				if ( PointToTarget == None)
				{
					if ( MHTarget.IsA('NsWayPoint') && NsWayPoint(MHTarget).MyPoint != None )
					{
						PointToTarget = NsWayPoint(MHTarget).MyPoint;
					}
				}
				else
				{
					if ( VSize( PointToTarget.Location - aBot.Location ) < 30 )
					{
						aBot.Target = MHTarget;
						aBot.MoveTarget = MHTarget;
						aBot.MoveTimer = 1.0;
					}
					else
						if ( aBot.ActorReachable(PointToTarget)
						&& !FastTrace(aBot.Location,MHTarget.Location)
						&& aBot.MoveTarget != MHTarget )
							aBot.MoveTarget = PointToTarget;
						else
							{
								MHPath = aBot.FindPathToward(PointToTarget);
								if (MHPath != None)
								{
									aBot.MoveTarget = MHPath;
									aBot.Destination = MHPath.Location;
								}
							}
					bFound = ( MHPath != None || aBot.MoveTarget != None );
					if ( bFound )
					{
						if ( aBot.Enemy != None )
							aBot.bReadyToAttack = true;
						if (!aBot.bCampOnlyOnce
						&& aBot.SpecialPause == 0 )
						{
							SetAttractionStateFor(aBot);
							return true;
						}
					}
				}
			}
		}
	}
	}
	return false;
}

function bool ValidSight(Pawn S,Bot aBot)
{
	local bool result;
	local actor HitActor;
	local vector HitLocation, HitNormal;

	result=False;
	if ( S == None || aBot == None )
		result=False;
	HitActor = Trace(HitLocation, HitNormal, S.Location, aBot.Location, false);
	if ( HitActor == None )
		result = True;
	return result;
}

function bool NearANode(Bot aBot) //Added for attraction
{
	local bool bIsNearby;
	local Pathnode P;

	bIsNearby = False;

	foreach aBot.RadiusActors( class 'Pathnode',P, 700 )
	{
		if ( P != None && FastTrace(aBot.Location,P.Location) )
		{
			bIsNearby = True;
			break;
		}
	}
	return bIsNearby;
}

function int ReduceDamage(int Damage, name DamageType, pawn injured, pawn instigatedBy) //screwed properly
{
	if (injured.Region.Zone.bNeutralZone)
		return 0;

	if ( instigatedBy == None)
		return Damage;

	if ( bHardCoreMode ) //THIS IS THE ONLY REASON NOT GAME-SPEED
		Damage *= 1.5;

	Damage *= InstigatedBy.DamageScaling;
	if ( bNoviceMode && !bThreePlus )
	{
		if ( instigatedBy.bIsPlayer && instigatedby.PlayerReplicationInfo != None && (injured == instigatedby) && (Level.NetMode == NM_Standalone) )
			Damage *= 0.5;

		//skill level modification
		if ( instigatedBy.IsA('Bot') && injured.IsA('PlayerPawn') )
		{
			if ( ((instigatedBy.Weapon != None) && instigatedBy.Weapon.bMeleeWeapon) 
				|| ((injured.Weapon != None) && injured.Weapon.bMeleeWeapon && (VSize(injured.location - instigatedBy.Location) < 600)) )
				Damage = Damage * (0.76 + 0.08 * instigatedBy.skill);
			else
				Damage = Damage * (0.25 + 0.15 * instigatedBy.skill);
		}
	}
	if ( InstigatedBy != None && injured != None && injured != InstigatedBy && injured.Health > 0 && injured.IsA('ScriptedPawn') && !InstigatedBy.IsA('ScriptedPawn') )
	{
		ScriptedPawn(injured).Hated = InstigatedBy;
		if (FRand() > 0.6)
		{
			ScriptedPawn(injured).Enemy = InstigatedBy;
			ScriptedPawn(injured).LastSeenPos = InstigatedBy.Location;
			ScriptedPawn(injured).Target = InstigatedBy;
		}
	}
	if ( instigatedBy != None && injured != None && ( injured == InstigatedBy || injured != instigatedBy ) && instigatedby.PlayerReplicationInfo == None )
			return Damage;

	if ( (instigatedBy != injured) && injured.PlayerReplicationInfo != None && instigatedBy.PlayerReplicationInfo != None
		&& (injured.PlayerReplicationInfo.Team ~= instigatedBy.PlayerReplicationInfo.Team) )
	{
		if ( injured.IsA('Bot') )
			Bot(Injured).YellAt(instigatedBy);
		return (Damage * FriendlyFireScale);
	}
	return Damage;
}

function SetForcedStateFor(Bot aBot) //called by attraction
{
	aBot.bNoClearSpecial = true;
	aBot.TweenToRunning(0.1);
	if (!aBot.IsInState('Roaming') && Vsize(aBot.MoveTarget.Location - aBot.Location) > 300 )
		aBot.GotoState('Roaming','SpecialNavig');
}

function bool NeverStakeOut(Bot Other) //Assault related thing - Added
{
	if ( Other.Region.Zone.bWaterZone || Other.Region.Zone.IsA('KillingField') )
		return True;
	return False;
}

/*
function bool CanStakeOut(ScriptedPawn Other)
{
	if ( Other.Region.Zone.bWaterZone || Other.Region.Zone.IsA('KillingField') )
		return False;
	log ("Call monster stack-out");
	return True;
}
Compilable but never called - monster is a kind of crap
*/
function CountMonsters()
{
	local Pawn P;
	local ScriptedPawn S;

	TotalMonsters = 0;
		//Reset monsters number counter
		//Something died, we count monsters to check how many they are
	for (P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		S = ScriptedPawn(P);
		if (S != None)
		{
			if (S.Health >= 1)
			TotalMonsters ++;					//Ye, especially if some of them have jumped in lava trying to kill me :D
		}
	}
	MonsterReplicationInfo2(GameReplicationInfo).Monster = TotalMonsters;
}
/*
function ChangeName(Pawn Other, string S, bool bNameChange)
{
	local pawn APlayer;

	if ( S == "" )
		return;

	S = left(S,24);
	if (Other.PlayerReplicationInfo.PlayerName~=S)
		return;

	APlayer = Level.PawnList;

	While ( APlayer != None )
	{
		if ( !APlayer.bIsPlayer || APlayer.PlayerReplicationInfo == None ) {}
		if ( APlayer.bIsPlayer && (APlayer.PlayerReplicationInfo.PlayerName~=S) )
		{
			Other.ClientMessage(S$NoNameChange);
			return;
		}
		APlayer = APlayer.NextPawn;
	}
	if ( Other.PlayerReplicationInfo != None && Other.bIsPlayer )
	{
		Other.PlayerReplicationInfo.OldName = Other.PlayerReplicationInfo.PlayerName;
		Other.PlayerReplicationInfo.PlayerName = S;
		if ( bNameChange && !Other.IsA('Spectator') )
			BroadcastLocalizedMessage( DMMessageClass, 2, Other.PlayerReplicationInfo );
	
		if (LocalLog != None)
			LocalLog.LogNameChange(Other);
		if (WorldLog != None)
			WorldLog.LogNameChange(Other);
	}
}

*/
function ChangeName(Pawn Other, string S, bool bNameChange) //This is called returning some errors... Fixed ?
{
	if ( S == "" )
		return;
	S = left(S,24);
	if ( Other.PlayerReplicationInfo.PlayerName~=S || Other.PlayerReplicationInfo == None )
		return;
	Super(GameInfo).ChangeName(Other, S, bNameChange);
}

function SetBotOrders(Bot NewBot) //This is called as well returning errors - Fixed ?
{
	local Pawn P, L;
	local int num, total;

	NewBot.bJumpy = True;
	NewBot.BaseAggressiveness = NewBot.Default.BaseAggressiveness+0.3;
	if ( IsOnTeam(NewBot,0) )
	{
		NewBot.SetOrders('Freelance', None, true);
		return;
	}
}

function DiscardInventory( Pawn Other ) //Guess why I did a... small look around
{
	local actor dropped;
	local inventory Inv;
	local weapon weap;
	local float speed;

	bHaveASpawn=True; //This has been called - look out how we replace stuff dropped in Base_Mute
	if( Other.DropWhenKilled != None )
	{
		dropped = Spawn(Other.DropWhenKilled,,,Other.Location); //Break in here if replacement works - next lines won't act anymore
		Inv = Inventory(dropped);
		if ( Inv != None )
		{
			Inv.RespawnTime = 0.0; //don't respawn - Nelsona: For sure not even replacements - except from decorations... RIGHT ???
			Inv.BecomePickup();
		}
		if ( dropped != None )
		{
			dropped.RemoteRole = ROLE_DumbProxy;
			dropped.SetPhysics(PHYS_Falling);
			dropped.bCollideWorld = true;
			dropped.Velocity = Other.Velocity + VRand() * 280;
		}
		if ( Inv != None )
			Inv.GotoState('PickUp', 'Dropped');
	}
	if( (Other.Weapon!=None) && (Other.Weapon.Class!=Level.Game.BaseMutator.MutatedDefaultWeapon()) 
		&& Other.Weapon.bCanThrow )
	{
		speed = VSize(Other.Velocity);
		weap = Other.Weapon;
		if (speed != 0)
			weap.Velocity = Normal(Other.Velocity/speed + 0.5 * VRand()) * (speed + 280);
		else {
			weap.Velocity.X = 0;
			weap.Velocity.Y = 0;
			weap.Velocity.Z = 0;
		}
		Other.TossWeapon();
		if ( weap.PickupAmmoCount == 0 )
			weap.PickupAmmoCount = 1;
	}
	Other.Weapon = None;
	Other.SelectedItem = None;
	for( Inv=Other.Inventory; Inv!=None; Inv=Inv.Inventory )
		Inv.Destroy();
	bHaveASpawn=False; //End, prepare to next one
}

//***************************************************************************
// Next section will call other things related to a Tournament form of a game
// HUD, Scoreboard, rules, values, etc.
// In fact we have to choose from 3 HUDS in this version:
// SIMPLE-UnrealHUD, A close to original MH one, An improved with radar one.
// These are set by BaseMutator called by current controller for other needs.
// Even we can define some nasty death messages ...
//***************************************************************************

defaultproperties
{
     bUseLive=True
     bNoGreen=True
     bDoSpawnSpamFix=True
     bFixCounters=True
     StartUpMessage="Work with your team-mates to hunt down the monsters!"
     StartUpTeamMessage="Welcome to Monster Hunt!"
     TT=mn
     Live=999
     SkillMonster=7
     Ncheck=20
     Pen=0.800000
     TimeOutMessage="Time up, hunt failed!"
     bNoTeamChanges=True
     bBalanceTeams=False
     bPlayersBalanceTeams=False
     FriendlyFireScale=0.050000
     MaxAllowedTeams=2
     TimeLimit=200
     NetWait=2
     RestartWait=2
     StartMessage="Monster Hunt has begun!"
     GameEndedMessage="Hunt Successfull!"
     SingleWaitingMessage="Hit Fire to begin the hunt."
     InitialBots=5
     ExplodeMessage=" was directly blown up"
     FallMessage=" left just a small crater."
     DrownedMessage=" has drowned because of missing air."
     BurnedMessage=" was so incinerated"
     CorrodedMessage=" was nasty slimed"
     HackedMessage=" was successfully hacked"
     MortarMessage=" was blasted by a mortar."
     SuicideMessage=" had a sudden heart attack."
     bCanChangeSkin=True
     TEAM_Blue=0
     TEAM_Green=0
     TEAM_Gold=0
     DefaultWeapon=Class'MH2_NS_V2.MHDispersionPistol'
     ScoreBoardType=Class'MH2_NS_V2.NSMHScoreBoard'
     BotMenuType="MH2_NS_V2.Monster2BotConfig"
     RulesMenuType="MH2_NS_V2.Monster2HuntRules"
     SettingsMenuType="MH2_NS_V2.Monster2Settings"
     HUDType=Class'MH2_NS_V2.NSMonsterHUD'
     MapListType=Class'MonsterHunt.MonsterMapList'
     MapPrefix="MH"
     LeftMessage=" left the hunt."
     EnteredMessage=" has joined the hunt!"
     GameName="MonsterHunt"
     DMMessageClass=Class'MH2_NS_V2.HuntMessage'
     MutatorClass=Class'MH2_NS_V2.MonsterBasePlus'
     GameReplicationInfoClass=Class'MH2_NS_V2.MonsterReplicationInfo2'
     bLocalLog=False
     AdminPassword=
     StatLogClass=Class'MH2_NS_V2.MHLogFile'
}
