class MHTazerProj expands TazerProj;

function SuperExplosion()
{
	local MHRingExplosion2 r;

	HurtRadius(Damage*3.9, 240, 'jolted', MomentumTransfer*2, Location );
	r = Spawn(Class'MHRingExplosion2',,'',Location, Instigator.ViewRotation);
	r.PlaySound(r.ExploSound,,25.0,,1500,0.6);
	Destroy(); 
}

simulated function PostBeginPlay()		//decals or no decals?
{							//Nelsona: LOL...
	Super.PostBeginPlay();
	ExplosionDecal=Class'Botpack.EnergyImpact';
}

function ProcessTouch (Actor Other, vector HitLocation)
{
	If (Other != Instigator && TazerProj(Other)==None)
	{
		Explode(HitLocation,Normal(HitLocation-Other.Location));
	}
}

function Explode(vector HitLocation,vector HitNormal)
{
	local RingExplosion r;
	if (Instigator == None || Instigator.health < 0)
		bReplicateInstigator = False;
	PlaySound(ImpactSound, SLOT_Misc, 0.5,,, 0.5+FRand());
	HurtRadius(Damage, 70, 'jolted', MomentumTransfer, Location );
	if (Damage > 60)
		r = Spawn(class'RingExplosion3',,, HitLocation+HitNormal*8,rotator(HitNormal));
	else
		r = Spawn(class'RingExplosion',,, HitLocation+HitNormal*8,rotator(HitNormal));

	r.PlaySound(r.ExploSound,,6);
	Destroy();
}

defaultproperties
{
}
