//=============================================================================
// NSMH_AGKMessage.
//=============================================================================
class NSMH_AGKMessage expands LocalMessagePlus;

#exec AUDIO IMPORT FILE="Sounds\ious.wav" NAME="ious" GROUP="Snd"

static function float GetOffset(int Switch, float YL, float ClipY )
{
	return (Default.YPos/768.0) * ClipY + YL;
}

static function int GetFontSize( int Switch )
{
	return 2;
}

static function string GetString(
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject 
	)
{
	if(Switch == 9999)
		return RelatedPRI_1.PlayerName@"is a freak team killer !";
	else if(Switch > 0)
		return "Stop shooting players! Are you mad ? "@RelatedPRI_1.PlayerName@" Remaining Life:"@Switch;
	else
		return "You are a loser team killer, you killed:"@RelatedPRI_1.PlayerName;
	return "";
}

static function ClientReceive( 
	PlayerPawn P,
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{

	Super.ClientReceive(P, Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
	if(Switch <= 0 || Switch == 9999)
			P.ClientPlaySound(sound'MH2_NS_V2.Snd.ious',, True);
	return;
}

defaultproperties
{
     FontSize=1
     bIsSpecial=True
     bIsUnique=True
     bFadeMessage=True
     DrawColor=(B=0)
     YPos=172.000000
     bCenter=True
}
